<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (150)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="from-the-orbital-height">From the orbital height</h1>
    <p>
      This section describes a set of modern standards for “web components”.
    </p>
    <p>
      As of now, these standards are under development. Some features are
      well-supported and integrated into the modern HTML/DOM standard, while
      others are yet in draft stage. You can try examples in any browser, Google
      Chrome is probably the most up to date with these features. Guess, that’s
      because Google fellows are behind many of the related specifications.
    </p>
    <h2 id="whats-common-between">What’s common between…</h2>
    <p>
      The whole component idea is nothing new. It’s used in many frameworks and
      elsewhere.
    </p>
    <p>
      Before we move to implementation details, take a look at this great
      achievement of humanity:
    </p>
    <p><img src="satellite.jpg" /></p>
    <p>That’s the International Space Station (ISS).</p>
    <p>And this is how it’s made inside (approximately):</p>
    <p><img src="satellite-expanded.jpg" /></p>
    <p>The International Space Station:</p>
    <ul>
      <li>Consists of many components.</li>
      <li>Each component, in its turn, has many smaller details inside.</li>
      <li>
        The components are very complex, much more complicated than most
        websites.
      </li>
      <li>
        Components are developed internationally, by teams from different
        countries, speaking different languages.
      </li>
    </ul>
    <p>…And this thing flies, keeps humans alive in space!</p>
    <p>How such complex devices are created?</p>
    <p>
      Which principles we could borrow to make our development same-level
      reliable and scalable? Or, at least, close to it.
    </p>
    <h2 id="component-architecture">Component architecture</h2>
    <p>
      The well known rule for developing complex software is: don’t make complex
      software.
    </p>
    <p>
      If something becomes complex – split it into simpler parts and connect in
      the most obvious way.
    </p>
    <p>
      <strong
        >A good architect is the one who can make the complex simple.</strong
      >
    </p>
    <p>
      We can split user interface into visual components: each of them has own
      place on the page, can “do” a well-described task, and is separate from
      the others.
    </p>
    <p>Let’s take a look at a website, for example Twitter.</p>
    <p>It naturally splits into components:</p>
    <p><img src="web-components-twitter.svg" /></p>
    <ol type="1">
      <li>Top navigation.</li>
      <li>User info.</li>
      <li>Follow suggestions.</li>
      <li>Submit form.</li>
      <li>(and also 6, 7) – messages.</li>
    </ol>
    <p>
      Components may have subcomponents, e.g. messages may be parts of a
      higher-level “message list” component. A clickable user picture itself may
      be a component, and so on.
    </p>
    <p>
      How do we decide, what is a component? That comes from intuition,
      experience and common sense. Usually it’s a separate visual entity that we
      can describe in terms of what it does and how it interacts with the page.
      In the case above, the page has blocks, each of them plays its own role,
      it’s logical to make these components.
    </p>
    <p>A component has:</p>
    <ul>
      <li>Its own JavaScript class.</li>
      <li>
        DOM structure, managed solely by its class, outside code doesn’t access
        it (“encapsulation” principle).
      </li>
      <li>CSS styles, applied to the component.</li>
      <li>
        API: events, class methods etc, to interact with other components.
      </li>
    </ul>
    <p>Once again, the whole “component” thing is nothing special.</p>
    <p>
      There exist many frameworks and development methodologies to build them,
      each with its own bells and whistles. Usually, special CSS classes and
      conventions are used to provide “component feel” – CSS scoping and DOM
      encapsulation.
    </p>
    <p>
      “Web components” provide built-in browser capabilities for that, so we
      don’t have to emulate them any more.
    </p>
    <ul>
      <li>
        <a
          href="https://html.spec.whatwg.org/multipage/custom-elements.html#custom-elements"
          >Custom elements</a
        >
        – to define custom HTML elements.
      </li>
      <li>
        <a href="https://dom.spec.whatwg.org/#shadow-trees">Shadow DOM</a> – to
        create an internal DOM for the component, hidden from the others.
      </li>
      <li>
        <a href="https://drafts.csswg.org/css-scoping/">CSS Scoping</a> – to
        declare styles that only apply inside the Shadow DOM of the component.
      </li>
      <li>
        <a href="https://dom.spec.whatwg.org/#retarget">Event retargeting</a>
        and other minor stuff to make custom components better fit the
        development.
      </li>
    </ul>
    <p>
      In the next chapter we’ll go into details of “Custom Elements” – the
      fundamental and well-supported feature of web components, good on its own.
    </p>
  </body>
</html>
